package it.unisannio.ding.ids.wedroid.wrapper.entity;

import com.google.gson.annotations.SerializedName;

import java.util.Date;
import java.util.List;

public class Board {
    @SerializedName("_id")
    private String id;
    private String title;
    private String slug;
    private boolean archived;
    private Date createdAt;
    private Date modifiedAt;
    private int starts;
    private List<Label> labels;
    private List<Member> members;
    private BoardPermission permission;
    @SerializedName("color")
    private BoardBackgroundColor backgroundColor;
    private String description;
    private String subtasksDefaultBoardId;
    private String subtasksDefaultListId;
    private boolean allowsSubtasks;
    private PresentParentTask presentParentTask;
    private Date startAt;
    private Date dueAt;
    private Date endAt;
    private int spentTime;
    private boolean isOvertime;
    private String type;
    private String defaultSwimlaneId;

    public String getId() {
        return id;
    }

    public String getTitle() {
        return title;
    }

    public String getSlug() {
        return slug;
    }

    public boolean isArchived() {
        return archived;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public Date getModifiedAt() {
        return modifiedAt;
    }

    public int getStarts() {
        return starts;
    }

    public List<Label> getLabels() {
        return labels;
    }

    public List<Member> getMembers() {
        return members;
    }

    public BoardPermission getPermission() {
        return permission;
    }

    public BoardBackgroundColor getBackgroundColor() {
        return backgroundColor;
    }

    public String getDescription() {
        return description;
    }

    public String getSubtasksDefaultBoardId() {
        return subtasksDefaultBoardId;
    }

    public String getSubtasksDefaultListId() {
        return subtasksDefaultListId;
    }

    public boolean isAllowsSubtasks() {
        return allowsSubtasks;
    }

    public PresentParentTask getPresentParentTask() {
        return presentParentTask;
    }

    public Date getStartAt() {
        return startAt;
    }

    public Date getDueAt() {
        return dueAt;
    }

    public Date getEndAt() {
        return endAt;
    }

    public int getSpentTime() {
        return spentTime;
    }

    public boolean isOvertime() {
        return isOvertime;
    }

    public String getType() {
        return type;
    }

    public String getDefaultSwimlaneId() {
        return defaultSwimlaneId;
    }

    @Override
    public String toString() {
        return "Board{" +
                "id='" + id + '\'' +
                ", title='" + title + '\'' +
                ", slug='" + slug + '\'' +
                ", archived=" + archived +
                ", createdAt=" + createdAt +
                ", modifiedAt=" + modifiedAt +
                ", starts=" + starts +
                ", labels=" + labels +
                ", members=" + members +
                ", permission=" + permission +
                ", backgroundColor=" + backgroundColor +
                ", description='" + description + '\'' +
                ", subtasksDefaultBoardId='" + subtasksDefaultBoardId + '\'' +
                ", subtasksDefaultListId='" + subtasksDefaultListId + '\'' +
                ", allowsSubtasks=" + allowsSubtasks +
                ", presentParentTask=" + presentParentTask +
                ", startAt=" + startAt +
                ", dueAt=" + dueAt +
                ", endAt=" + endAt +
                ", spentTime=" + spentTime +
                ", isOvertime=" + isOvertime +
                ", type='" + type + '\'' +
                ", defaultSwimlaneId='" + defaultSwimlaneId + '\'' +
                '}';
    }
}
