package it.unisannio.ding.ids.wedroid.wrapper.entity;

import com.google.gson.annotations.SerializedName;
import java.util.Date;
import java.util.List;

public class Card {

    //Constructor for add card
    public Card(String authorId, String title, String swimlaneId, String description) {
        this.authorId= authorId;
        this.title = title;
        this.swimlaneId = swimlaneId;
        this.description = description;
    }

    public Card() {
    }

    public String getAuthorId() {
        return authorId;
    }

    public void setAuthorId(String authorId) {
        this.authorId = authorId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Boolean getArchived() {
        return archived;
    }

    public void setArchived(Boolean archived) {
        this.archived = archived;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getListId() {
        return listId;
    }

    public void setListId(String listId) {
        this.listId = listId;
    }

    public String getSwimlaneId() {
        return swimlaneId;
    }

    public void setSwimlaneId(String swimlaneId) {
        this.swimlaneId = swimlaneId;
    }

    public String getBoardId() {
        return boardId;
    }

    public void setBoardId(String boardId) {
        this.boardId = boardId;
    }

    public String getCoverId() {
        return coverId;
    }

    public void setCoverId(String coverId) {
        this.coverId = coverId;
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getModifiedAt() {
        return modifiedAt;
    }

    public void setModifiedAt(Date modifiedAt) {
        this.modifiedAt = modifiedAt;
    }

    public List<String> getCustomFields() {
        return customFields;
    }

    public void setCustomFields(List<String> customFields) {
        this.customFields = customFields;
    }

    public Date getDateLastActivity() {
        return dateLastActivity;
    }

    public void setDateLastActivity(Date dateLastActivity) {
        this.dateLastActivity = dateLastActivity;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getRequestedBy() {
        return requestedBy;
    }

    public void setRequestedBy(String requestedBy) {
        this.requestedBy = requestedBy;
    }

    public String getAssignedBy() {
        return assignedBy;
    }

    public void setAssignedBy(String assignedBy) {
        this.assignedBy = assignedBy;
    }

    public List<String> getLabelIds() {
        return labelIds;
    }

    public void setLabelIds(List<String> labelIds) {
        this.labelIds = labelIds;
    }

    public List<String> getMembers() {
        return members;
    }

    public void setMembers(List<String> members) {
        this.members = members;
    }

    public List<String> getAssignees() {
        return assignees;
    }

    public void setAssignees(List<String> assignees) {
        this.assignees = assignees;
    }

    public Date getReceivedAt() {
        return receivedAt;
    }

    public void setReceivedAt(Date receivedAt) {
        this.receivedAt = receivedAt;
    }

    public Date getStartAt() {
        return startAt;
    }

    public void setStartAt(Date startAt) {
        this.startAt = startAt;
    }

    public Date getDueAt() {
        return dueAt;
    }

    public void setDueAt(Date dueAt) {
        this.dueAt = dueAt;
    }

    public Date getEndAt() {
        return endAt;
    }

    public void setEndAt(Date endAt) {
        this.endAt = endAt;
    }

    public int getSpentTime() {
        return spentTime;
    }

    public void setSpentTime(int spentTime) {
        this.spentTime = spentTime;
    }

    public Boolean getOvertime() {
        return isOvertime;
    }

    public void setOvertime(Boolean overtime) {
        isOvertime = overtime;
    }


    public int getSort() {
        return sort;
    }

    public void setSort(int sort) {
        this.sort = sort;
    }

    public int getSubtaskSort() {
        return subtaskSort;
    }

    public void setSubtaskSort(int subtaskSort) {
        this.subtaskSort = subtaskSort;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getLinkedId() {
        return linkedId;
    }

    public void setLinkedId(String linkedId) {
        this.linkedId = linkedId;
    }

    @Override
    public String toString() {
        return "Card{" +
                "id='" + id + '\'' +
                ", title='" + title + '\'' +
                ", archived=" + archived +
                ", parentId='" + parentId + '\'' +
                ", listId='" + listId + '\'' +
                ", swimlaneId='" + swimlaneId + '\'' +
                ", boardId='" + boardId + '\'' +
                ", coverId='" + coverId + '\'' +
                ", color='" + color + '\'' +
                ", createdAt=" + createdAt +
                ", modifiedAt=" + modifiedAt +
                ", customFields=" + customFields +
                ", dateLastActivity=" + dateLastActivity +
                ", description='" + description + '\'' +
                ", requestedBy='" + requestedBy + '\'' +
                ", assignedBy='" + assignedBy + '\'' +
                ", labelIds=" + labelIds +
                ", members=" + members +
                ", assignees=" + assignees +
                ", receivedAt='" + receivedAt + '\'' +
                ", startAt='" + startAt + '\'' +
                ", dueAt='" + dueAt + '\'' +
                ", endAt='" + endAt + '\'' +
                ", spentTime=" + spentTime +
                ", isOvertime=" + isOvertime +
                ", userId='" + authorId + '\'' +
                ", sort=" + sort +
                ", subtaskSort=" + subtaskSort +
                ", type='" + type + '\'' +
                ", linkedId='" + linkedId + '\'' +
                '}';
    }

    @SerializedName("_id")
    private String id;
    private String title;
    private Boolean archived;
    private String parentId;
    private String listId;
    private String swimlaneId;
    private String boardId;
    private String coverId;
    private Color color;
    private Date createdAt;
    private Date modifiedAt;
    private List<String> customFields;
    private Date dateLastActivity;
    private String description;
    private String requestedBy;
    private String assignedBy;
    private List<String> labelIds;
    private List<String> members;
    private List<String> assignees;
    private Date receivedAt;
    private Date startAt;
    private Date dueAt;
    private Date endAt;
    private int spentTime;
    private Boolean isOvertime;
    //private String userId;
    private int sort;
    private int subtaskSort;
    private String type;
    private String linkedId;
    @SerializedName(value = "authorId", alternate = "userId")
    private String authorId;
}
