package it.unisannio.ding.ids.wedroid.wrapper.entity;

public class MemberPermission {
    /**
     * The user is an admin of the board
     */
    public final static MemberPermission ADMIN = new MemberPermission(
            true,
            false,
            false
    );

    /**
     * The use is an normal member of the board
     */
    public final static MemberPermission NORMAL = new MemberPermission(
            false,
            false,
            false
    );

    /**
     * The user isn't allowed to make comments on the board
     */
    public final static MemberPermission NO_COMMENTS = new MemberPermission(
            false,
            true,
            false
    );

    /**
     * The user is only allowed to make comments on the board
     */
    public final static MemberPermission COMMENT_ONLY = new MemberPermission(
            false,
            false,
            true
    );

    private boolean isAdmin;
    private boolean isNoComments;
    private boolean isCommentOnly;

    private MemberPermission(boolean isAdmin, boolean isNoComments, boolean isCommentOnly) {
        this.isAdmin = isAdmin;
        this.isNoComments = isNoComments;
        this.isCommentOnly = isCommentOnly;
    }

    public boolean isAdmin() {
        return isAdmin;
    }

    public boolean isNoComments() {
        return isNoComments;
    }

    public boolean isCommentOnly() {
        return isCommentOnly;
    }
}
